#version 330

in vec3 vertex;
in vec3 normal;
//in vec3 texturec;
in vec3 colorc;
out vec3 colord;

uniform mat4 Projection;
uniform mat4 View;
uniform mat4 Model;
uniform vec3 light_position;

out vec3 light_vector;
out vec3 normal_vector;
out vec3 halfway_vector;
//out float fog_factor;
//out vec2 tex_coord;

void main() {
	vec4 v = vec4(vertex, 1.0);

	gl_Position = View * Model * v;
	//fog_factor = min(-gl_Position.z/300000.0, 1.0);
	gl_Position = Projection * gl_Position;

	v = View * Model * v;
	vec3 normal1 = normalize(normal);

	light_vector = normalize((View * vec4(light_position, 1.0)).xyz - v.xyz);
	normal_vector = (inverse(transpose(View * Model)) * vec4(normal1, 0.0)).xyz;
        halfway_vector = light_vector + normalize(-v.xyz);

	//tex_coord = texturec.xy;
	colord=colorc;
}